/* room15.h - Treasury
 * Created: 2. August 1999 
 * Last modified: 3. August 1999

 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init15(char string[]);
void desc15(Room []);
void look15(Room [], char [], char [], char []);
void cast15(Myr &, char [], char []);
void take15(Myr &, Room [], char [], char []);

void room15(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc15(rooms);

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You leave the treasury." << endl;
      rooms[14].setPrevRoom(15);
      setroom = 14;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
      cout << "You can't go in that direction." << endl;
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look15(rooms, token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast15(wytch, token2, token3);
    }
    else if (!strcmp(token, "get") || !strcmp(token, "take"))
      take15(wytch, rooms, token2, token3);
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 4); // 4 is just a general number for now
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[15].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init15(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init15(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc15()                                             *
 * Gives the room description                            *
 ********************************************************/
void desc15(Room rooms[])
{
  cout << 
  endl << "You are in the treasury.  As you would expect of a treasury, it" << 
  endl << "has an amass of various wealth and artifacts." << endl;
  if (rooms[15].getMiscvar(0) == 1)
  {
    cout << "Your lost items are stored here.  You see:" << endl;
    rooms[15].printItem();
  }
}


/*********************************************************
 * look15()                                             *
 ********************************************************/
void look15(Room rooms[], char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "ground") || !strcmp(token2, "floor"))
  {
    cout << "You look on the ground and see:" << endl;
    rooms[15].printItem();
  }
  if (!strcmp(token2, "room") || !strcmp(token2, "treasury"))
    desc15(rooms);
  else if (!strcmp(token2, "\0"))
    desc15(rooms);
  else
    cout << "";
}


/*********************************************************
 * cast15()                                             *
 ********************************************************/
void cast15(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
  }
}

void take15(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "money") || !strcmp(token2, "gold"))
  {
    cout << "While all that money is highly tempting, you won't need it "<<
    endl << "in this demo since money is never used.  Isn't that the thing"<<
    endl << "which sucks about demos?  You never can do all that you want."<<
    endl;
  }
  else if (!strcmp(token2, "stuff"))
  {
    cout << "You retrieve your lost possessions.  You now have your"<<
    endl << "staff, tinderbox, healing potion, and essence potion back." << 
    endl;
    wytch.insertInv("tinderbox", 1);
    wytch.insertInv("staff", 1); // need to put this under a weapons catagory
    wytch.insertInv("healing potion", 1);
    wytch.insertInv("essence potion", 1);
    rooms[15].removeItem("tinderbox");
    rooms[15].removeItem("staff");
    rooms[15].removeItem("healing potion");
    rooms[15].removeItem("essence potion");
  }
  else if (!strcmp(token2, "potion"))
    cout << "Which type of potion are you trying to take?" << endl;
  else if (!strcmp(token3, "potion"))
  {
    if (!strcmp(token2, "healing"))
    {
      wytch.insertInv("healing potion", 1);
      rooms[15].removeItem("healing potion");
    }
    else if (!strcmp(token2, "essence"))
    {
      wytch.insertInv("essence potion", 1);
      rooms[15].removeItem("essence potion");
    }
    else
      cout << "What type of potion are you trying to take?" << endl;
  }
  else if (rooms[15].searchItem(token2) != 0)
  {
    wytch.insertInv(token2, 1);
    rooms[15].removeItem(token2);
  }
  else
    cout << "What are you trying to get?" << endl;
}
