/* room9.h - Hallway
 * Created: 26. July 1999 
 * Last modified: 26. July 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init9(char string[]);
void desc9();
void look9(Myr &, Room [], char [], char []);
void cast9(Myr &, char [], char []);
void open9(Myr &, Room [], char [], char []);

void room9(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc9();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init9(token);
    init9(token2);
    init9(token3);
    init9(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
    {
      wytch.printInv();
    }
    else if (!strcmp(token, "stats"))
      wytch.stats();
        else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You descend the stairs to the lower level." << endl;
      rooms[8].setPrevRoom(9);
      setroom = 8;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "d") || !strcmp(token, "down"))
    {
      cout << "You descend the stairs to the second floor of the temple." <<
      endl;
      rooms[8].setPrevRoom(9);
      setroom = 8;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
    {
      if (rooms[9].doFunct2(0, "isLocked") == 1)
      {
        cout << "You will have to open the door first before you can go"<<
	endl << "in that direction." << endl;
      }
      else
      {
        cout << "Taking a deep breath, you walk through the double doors."<<
	endl;
        rooms[16].setPrevRoom(9);
        setroom = 16;
        strcpy(breakloop, "bye");
      }
    }
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
    {
      cout << "You walk down the hallway." << endl;
      rooms[11].setPrevRoom(9);
      setroom = 11;
      strcpy(breakloop, "bye");
      
    }
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
    {
      cout << "You walk down the hallway to the west." << endl << endl;
      rooms[10].setPrevRoom(9);
      setroom = 10;
      strcpy(breakloop, "bye");
    }
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look9(wytch, rooms, token2, token3);
    }
    else if (!strcmp(token, "cast"))
    {
      cast9(wytch, token2, token3);
    }
    else if (!strcmp(token, "open"))
      open9(wytch, rooms, token2, token3);
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[9].insertItem(token2, 1);
    }
    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init9(char string[])                                  *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init9(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc9()                                               *
 * Gives the room description                            *
 ********************************************************/
void desc9()
{
  cout <<
  endl << "You are standing in a corridor running east to west at the" <<
  endl << "top of a flight of stairs which lead down to the second floor." <<
  endl << "To the north is a set of double doors." << endl;
}


/*********************************************************
 * look9()                                             *
 ********************************************************/
void look9(Myr & wytch, Room rooms[], char token2[], char token3[])
{

  if (!strcmp(token2, "corridor") || !strcmp(token2, "hall"))
  {
    cout << "It is a fairly ordinary and dull, stone corridor running" <<
    endl << "in an east to west direction." << endl;
  }
  else if (!strcmp(token2, "door") || !strcmp(token2, "doors"))
  {
    if (rooms[9].doFunct2(0, "isLocked") == 1)
    {
    cout << "There are a large set of closed double doors in front of you"<< 
    endl << "with a large insignia is engraved into the door." << endl;
    }
    else
    {
      cout << "There are a large set of double doors swung open wide in "<<
      endl << "front of you." << endl;
    }
  }
  else if (!strcmp(token2, "insignia") || !strcmp(token2, "symbol"))
  {
    if (rooms[3].getMiscvar(0) == 0)
    {
      cout << "This is the same strange symbol you've seen in other" <<
      endl << "parts of the temple." << endl;
    }
    else
    {
      cout << "This strange Q-shaped symbol is the symbol of Angwyn."<<
      endl;
    }
  }
  else if (!strcmp(token2, "room"))
    desc9();
  else
    desc9();
}


/*********************************************************
 * cast9()                                               *
 ********************************************************/
void cast9(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0"))
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted); // check to see if spell is valid

  if (casted == 1)
  {
    if (!strcmp(token2, "Translate"))
    {
      cout << "You cast the Translate spell.  You now have the "<<
      endl << "ability to read strange and foreign languages." <<
      endl;
    }
    else if (!strcmp(token2, "Sense"))
    {
      cout << "You Sense a great deal of latent energies radiating from" << 
      endl << "the double doors." << endl;
    }
    else if (!strcmp(token2, "Psychic Block"))
    {
      cout << "Your spell prepares you to block off any psychic attacks."<<
      endl;
    }
    else
    {
      cout << "While there is no use for your spell here, you do "<<
      endl << "get in some practice." << endl;
    }
  }
}

void open9(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  char answer[7];

  if (!strcmp(token2, "door") || !strcmp(token2, "doors"))
  {
    cout << "A voice intones inside your head: 'What is the name of The"<<
    endl << "Great Being?'" << endl << "> ";
    cin >> answer;
    if (!strcmp(answer, "Angwyn"))
    {
      cout << "The voice again intones: 'You are correct, Believer.'"<<
      endl << "The door then swings open by itself." << endl;
      rooms[9].doFunct(0, "unlockDoor");
      rooms[9].doFunct(0, "openDoor");
    }
    else
    {
      cout << "A piercing shriek runs through your mind.  The Psychic";
      if (wytch.retSpellState("Psychic Block") == 1)
      {
        cout << "Blast has caused you to lose only 2 Life Points." <<
        endl << "You are thankful your Psychic Block spell helped to"<<
        endl << "reduce some of the force of the attack." << endl;
      }
      else
      {
        cout << "Blask has caused you to lose 5 Life Points." << endl;
        wytch.modLife(-5);
      }
    }
  }
}
