/* room0.h - Prison cell(old experiemental parser written in C)
 * Written 10. February 1999
 * Last modified: 9. August 1999
 */

#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>

void desc0(Room []);
void look(Myr &, char *, Room []);
void search(Room [], char[]);
void talk(char *, char *);
void open(Myr &, char *, char *, Room []);
void init(char string[]);
void cast(Myr &, char [], char [], Room []);
void take(Myr &, Room [], char []);

void room0(Myr & wytch, Room rooms[],  int & setroom)
{
  // declare variables
  char command[25], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";

  desc0(rooms);

  do
  {

  printf("\n> ");

  /* initialize the tokens */
  init(token);
  init(token2);
  init(token3);
  init(token4);

  gets(command);
  sscanf(command, "%s %s %s %s", token, token2, token3, token4);

  if (!strcmp(command, "exit game") || !strcmp(command, "quit game"))
  {
    strcpy(breakloop, "bye");
    setroom = 100;
  }
  else if (!strcmp(command, "quit"))
  {
    strcpy(breakloop, "bye");
    setroom = 100;
  }
  else if (!strcmp(command, "help"))
    help();
  else if (!strcmp(command, "tutorial"))
    tutorial();
  else if (!strcmp(command, "save") || !strcmp(command, "save game"))
    savegame(setroom, wytch, rooms);
  else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
    restoregame(setroom, wytch, rooms, breakloop);
  else if (!strcmp(token, "isLocked"))
    cout << "isLocked: " << rooms[0].doFunct2(3, "isLocked") << endl;
  else if (!strcmp(token, "isClosed"))
    cout << "isClosed: " << rooms[0].doFunct2(3, "isClosed") << endl;
  else if (!strcmp(token, "n") || !strcmp(token, "north"))
  {
    if (rooms[0].doFunct2(3, "isLocked") == 1)
    {
      cout << "You will first have to unlock the door before" <<
      endl << "you can ever hope to go in that direction." << endl;
    }
    else if (rooms[0].doFunct2(3, "isClosed") == 1)
    {
      cout << "You nimbly walk face first into the closed door." <<
      endl << "Try opening it first, you twit." << endl;
    }
    else
    {
      cout << "You exit the dungeon cell." << endl;
      rooms[1].setPrevRoom(0);
      setroom = 1;
      strcpy(breakloop, "bye");
    }
  }
  else if (!strcmp(token, "s") || !strcmp(token, "south"))
  {
    if (rooms[0].doFunct2(1, "isClosed") == 0)
    {
      cout << "Getting down on your hands and knees, you crawl " <<
      endl << "your way out of the dungeon cell. " << endl;
      rooms[7].setPrevRoom(0);
      setroom = 7;
      strcpy(breakloop, "bye");
    }
    else
    {
      cout << "You see no passage or door to the south, and hence, " <<
      endl << "you can't go in that direction." << endl;
    }
  }  
  else if (!strcmp(token, "unlock") && !strcmp(token2, "door"))
    cout << "Great idea, but how?" << endl;
  else if (!strcmp(token, "look"))
    look(wytch, token2, rooms);
  else if (!strcmp(token, "stats"))
    wytch.stats();
  else if (!strcmp(token, "inventory") || !strcmp(token, "i"))
   // wytch.inventory();
   wytch.printInv();
  else if (strcmp(token, "open") == 0)
    open(wytch, token2, token3, rooms);
  else if (!strcmp(token, "close"))
  {
    if (!strcmp(token2, "door"))
    {
      if (rooms[0].doFunct2(3, "getMisc") == 0)
      {
	cout << "Your spell destroyed most of the door, so there isn't"<<
        endl << "much left of the door to close anymore." << endl;
      }
      else if (rooms[0].doFunct2(3, "isClosed") == 1)
        cout << "The door is already closed, you dimwit." << endl;
      else
      {
        cout << "You close the door." << endl;
        rooms[0].doFunct(3, "closeDoor");
      }
    }
  }
  else if (!strcmp(token, "cast"))
  {
    cast(wytch, token2, token3, rooms);
  }
  else if (strcmp(token, "talk") == 0)
    talk(token2, token3);
  else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
  {
    cout << "Well, if that's the way you're going to be..." << endl;
    exit(1);
  }
  else if (!strcmp(token, "asshole"))
  {
    cout << "This game doesn't tolerate such foul language." << endl;
    exit(1);
  }
  else if (rooms[0].getMiscvar(0) == 0)
  {
    cout << "It's difficult to do much in the dark." << endl;
  }
  else if ((!strcmp(token, "get")) || (!strcmp(token, "take")))
  {
    take(wytch, rooms, token2);
  }
  else if (!strcmp(token, "drop"))
  {
    wytch.removeInv(token2);
    rooms[0].insertItem(token2, 1);
  }
  else if (!strcmp(token, "eat"))
    printf("You eat the %s\n", token2);
  else if (!strcmp(token, "isLocked"))
    cout << "isLocked: " << rooms[0].doFunct2(0, "isLocked");
  else if (!strcmp(token, "isClosed"))
    cout << "isClosed: " << rooms[0].doFunct2(0, "isClosed");
  else if (!strcmp(token, "search") || !strcmp(token, "touch"))
    search(rooms, token2);
  else if (!strcmp(token, "drink"))
    drink(wytch, token2, token3, 0);
  else if (strcmp(token, "kill") == 0)
    {
      if (!strcmp(token2, "guard"))
      {
        printf("It would be a lot easier to kill the guard if there\n");
        printf("was one here.\n");
      }
      else if (!strcmp(token2, "prisoner"))
      {
        printf("Um....you DO realize that the prisoner is already \n");
        printf("dead, don't you?  It's pretty silly to try and kill \n");
        printf("something that is already dead.\n");
      }
      else if (!strcmp(token2, "self"))
      {
        cout << "So, the pressure is getting to you, is it?  Well," <<
        endl << "don't worry since a 16 ton weight dropped on you," <<
        endl << "meting out your timely demise. Quite convienent, huh?" <<
        endl;
        setroom = 110;
        strcpy(breakloop, "bye");
      }
      else
        printf("You kill the %s\n", token2);
    }
  else
    printf("That did not make sense.\n");
  }
  while(strcmp(breakloop, "bye") != 0);

}

void desc0(Room rooms[])
{
  if (rooms[0].getMiscvar(0) == 0) // if light is off
  {
    cout << 
    endl << "You are in a small, cramped prison cell which reaks of a "<<
    endl << "combination of oily smoke, mildew, and other fragrances you"<<
    endl << "don't even want to chance putting name to.  In the weak " <<
    endl << "light, you can barely make out remnants of a former prisoner"<<
    endl << "laying in a lazy, awkward position along the floor.  To the"<< 
    endl << "north is the door, the only visible exit to this place." <<
    endl;
  }
  else
  {
    cout << 
    endl << "With the aid of your Illuminate spell, you can see your " <<
    endl << "surroundings much better, and the sight of it all makes you"<< 
    endl << "almost wish you couldn't.  Now the floors and walls and "<<
    endl << "everything else are much easier to see." << endl;
 // there was a stray semi-colon here 
  }

}

void look(Myr & wytch, char * object, Room rooms[])
{
  if (!strcmp(object, "prisoner"))
  {
    cout << "The former prisoner had been subjected to rot and the" <<
    endl << "rats, and not much remains except for the yellowed bones." <<
    endl;
  }
  else if (!strcmp(object, "room") || !strcmp(object, "cell"))
    desc0(rooms);
  else if (!strcmp(object, "rats"))
  {
    printf("While you do not see any rats here, you can hear them \n");
    printf("scurying inside the clammy walls.\n");
  }
  else if (!strcmp(object, "door"))
  {
    printf("The door has a small barred window which lets in a \n");
    printf("minimal amount of light.  ");
    if (rooms[0].doFunct2(3, "isClosed") == 1)
      cout << "It is currently closed." << endl;
    else
      cout << "It is currently open." << endl;
  }

  if (rooms[0].getMiscvar(0) == 1) // if light is on
  {
    if (!strcmp(object, "floor") || !strcmp(object, "ground"))
      if (rooms[0].searchItem("stone") == 1)
        cout << "On the filthy floor you see a hand-sized stone." << endl;
      else
        cout << "You see nothing on the filthy, urine-soaked ground." << endl;
    else if (!strcmp(object, "wall"))
    {
      if (rooms[0].doFunct2(1, "getMisc") == 0)
      {
      cout << "You search the wall and after removing some of the moss "
   << endl << "and mold from the wall, you make out the edge of what " <<
      endl << "appears to be a doorway.  You pull at the stones, and a "
   << endl << "large section of the wall falls free." << endl;
      rooms[0].doFunct(1, "openDoor");
      }
      else
      {
      cout << "You search along the wall, but don't see much of " <<
      endl << "interest, unless you consider moss and mold interesting."
      << endl;
      }
    }
    else if (!strcmp(object, "room"))
      desc0(rooms);
    else if (!strcmp(object, ""))
      desc0(rooms);
  }
  else if (rooms[0].getMiscvar(0) == 0)
    cout << "It's difficult to see much of anything in the dark." << endl;
  else
  {
    cout << "What is this " << object << " you are trying to look at?" <<
    endl;
  }
}

void search(Room rooms[], char token2[])
{
  if (!strcmp(token2, "wall"))
  {
    if (rooms[0].doFunct2(1, "getMisc") == 0)
    {
      cout << "You search the south wall and after removing some of the"<<
      endl << "moss and mold from the wall, you make out the edge of" <<
      endl << "what appears to be a doorway.  You pull at the stones, " <<
      endl << "and a large section of the wall falls free." << endl;
      rooms[0].doFunct(1, "openDoor");
    }
    else
    {
      cout << "You search along the wall, but don't see much of " <<
      endl << "interest, unless you consider moss and mold interesting."
      << endl;
    }
  }
  else if (!strcmp (token2, "prisoner"))
  {
    cout << "You search through the remains of the prisoner, but find " <<
    endl << "little of use." << endl;
  }
  else
    cout << "What are you trying to search for?" << endl;
}

void talk(char * token2, char * token3)
{
  if (strcmp(token2, "prisoner") == 0)
  {
    cout << "You talk to the prisoner but don't get much of a response." <<
    endl << "Dead people don't talk too often, you should know." << endl;
  }
  else if (strcmp(token2, "guard") == 0)
    printf("Despite your cries, there is no guard to hear you.\n");
  else if (strcmp(token2, "to") == 0 && strcmp(token3, "prisoner") == 0)
  {
    printf("You have a meaningful dialog with the remains of the ex-\n");
    printf("prisoner, unfortunately the bones don't have much to add.\n");
  }
  else if (strcmp(token2, "with") == 0 && strcmp(token3, "prisoner") ==0)
  {
    printf("You talk and talk and talk, but the ex-prisoner has\n");
    printf("nothing to say.  Perhaps the prisoner had been one of\n");
    printf("those strong silent types while alive.\n");
  }
  else if (!strcmp(token2, "to") && !strcmp(token3, "self"))
    printf("You talk to yourself.  Fun, isn't it?\n");
  else
  {
    printf("As much as you talk with the %s, you don't receive \n", token2);
    printf("much of an answer.  Perhaps if you tried talking to \n");
    printf("someone, or at least something, which will talk back.\n");
  }  
}

void open(Myr & wytch, char * token2, char * token3, Room rooms[])
{
  if (strcmp(token2, "the") == 0)
    strcpy(token2, token3);
  
  if (!strcmp(token2, "door"))
  {
    if (rooms[0].doFunct2(3, "getMisc") == 0)
    {
      cout << "The door has been destroyed by your spell, so there " <<
      endl << "isn't much left to open." << endl;
    }
    else if (rooms[0].doFunct2(3, "isClosed") == 0)
    {
      cout << "You slam the door open again and manage to smash your " <<
      endl << "fingers against the wall." << endl;
      wytch.modLife(-1);
    }
    else if (rooms[0].doFunct2(3, "isLocked") == 0)
    {
      cout << "You open the door." << endl;
      rooms[0].doFunct(3, "openDoor");
    }
    else
    {
      printf("That is a good idea, unfortunately your efforts are \n");
      printf("in vain since no effort you make opens the door.\n");
    }      
  }
  else
    cout << "Say what?" << endl;
}

void init(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}

void cast(Myr & wytch, char token2[], char token3[], Room rooms[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token3 is not NULL, then...
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
  if (!strcmp(token2, "Unlock"))
  {
    if (rooms[0].doFunct2(3, "isLocked") == 0)
    {
      cout << "You merely waste your spell since the door is already " <<
      endl << "unlocked.  You do get some practice, though." << endl <<
      endl;
    }
    else
    {
    cout << "As you cast the Unlock spell, you hear the lock making a " <<
    endl << "faint clicking sound.  The door is now unlocked." << endl;
    rooms[0].doFunct(3, "unlockDoor"); // unlock the door
    rooms[0].setMiscvar(2, 0); // unlock the door
    }
  }
  else if (!strcmp(token2, "Translate"))
  {
    cout << "You now have the ability to translate foreign languages"<< endl;
  }
  else if (!strcmp(token2, "Illuminate"))
  {
    cout << "Ah, much better!  Now you can see what you are doing." <<
    endl;
    rooms[0].setMiscvar(0, 1);
  }
  else if (!strcmp(token2, "Element Talk"))
  {
    cout << "You kneel down and place your hands on the cold, moist " <<
    endl << "floor of the dungeon.  Your mind reaches out to the Earth" <<
    endl << "trying to communicate with the stones which makes up your" <<
    endl << "prison.  You nearly pass out from the pain and agony the " <<
    endl << "stones have felt over the many, many years.  You strain " <<
    endl << "yourself further to communicate with the floor, asking " <<
    endl << "the rocks for aid to escape from this cell.  The rocks " <<
    endl << "are caught up in their own horror that it is difficult " <<
    endl << "for you to speak with them, but after your relentless " <<
    endl << "coaxing, the stones finally begin to listen.  You relate " <<
    endl << "to the stones that you are trying to escape, but you need "<<
    endl << "the aid of the Earth to help you find an exit.  The stones,"<<
    endl << "eager to distract themselves from their years of worrying,"<<
    endl << "agree to help you.  The rocks around the door begin to " <<
    endl << "shift and groan, causing the door to bend in an unwholely" <<
    endl << "unnatural way.  Under the stone's force, the door cracks " <<
    endl << "and splinters, allowing you and exit from this abyssmal " <<
    endl << "place." << endl;

    wytch.modLife(-2); // loss of LP from strain of spell
    wytch.modEssence(-3); // loss of EP 
    rooms[0].doFunct(3, "setMisc");
    rooms[0].doFunct(3, "unlockDoor"); 
    rooms[0].setMiscvar(2, 0); // unlock the door
    rooms[0].doFunct(3, "openDoor");
  }
  else if (!strcmp(token2, "Sense"))
  {
    cout << "You sense great oppression, sadness, and of course, the " <<
    endl << "raw stench of death.  A sliver of hope and salvation " <<
    endl << "tickles at the edges of your arcane peripheries, but you " <<
    endl << "can't quite make out what it is." << endl;
  }
  else if (!strcmp(token2, "History"))
  {
    cout << "You sense great oppression, sadness, and of course, the " <<
    endl << "raw stench of death.  A sliver of hope and salvation " <<
    endl << "nearly slips by your senses, but your hightened skills " <<
    endl << "allow you to make out a brief image of moving a stone " <<
    endl << "in the wall and exiting through a passage way." << endl;
    rooms[0].doFunct(1, "setMisc");
  }
  else if (!strcmp(token2, "Mental Key"))
  {
    if (rooms[0].doFunct2(3, "isLocked") == 0)
    {
      cout << "You merely waste your spell since the door is already " <<
      endl << "unlocked.  You do get some practice, though." << endl <<
      endl;
    }
    else
    {
    cout << "You close your eyes and imagine the lock mechanism " <<
    endl << "twisting and turning.  A faint 'click' rewards your" <<
    endl << "efforts.  The door is now unlocked." << endl << endl;
    rooms[0].doFunct(3, "unlockDoor"); 
    rooms[0].setMiscvar(2, 0); // unlock door
    }
  }
  else if (!strcmp(token2, "Create BloodStone"))
  {
    if (wytch.searchInv("stone") != 0)
    {
      cout << "You cast your spell on your stone and imbue it with " <<
      endl << "the Essence necessary to create a Magic Circle which " <<
      endl << "can help protect you when dealing with spirits." << endl;
      wytch.removeInv("stone");
      wytch.insertInv("BloodStone", 1);
    }
    else
    {
      cout << "After you cast your spell, you realize it was a waste " <<
      endl << "of your time and energy since you don't have a stone " <<
      endl << "in your possession to cast the spell upon. " << endl;
    }
  }
  else if (!strcmp(token2, "Spirit Talk"))
  {
    if (wytch.searchInv("BloodStone") != 0)
    {
      cout << "Using your BloodStone, you form a Magic Circle around " <<
      endl << "yourself to protect yourself from spirits.  As you " << 
      endl << "complete your spell, your body becomes locked in suspended"<<
      endl << "motion while your senses reach out to another plane of " <<
      endl << "existence.  The soul of the dead prisoner feels you " <<
      endl << "stretching out to the Dead.  Before you even attempt " <<
      endl << "to speak with the long lost prisoner, the spirit senses" <<
      endl << "your desires to escape from the prison which became his "<<
      endl << "final resting place.  He tells you about a concealed " <<
      endl << "passage way on the south wall of the prison which will" <<
      endl << "allow you to escape from the underground temple. Anxious"<< 
      endl << "to return to his Eternal Sleep, the spirit fades away." <<
      endl;
      rooms[0].doFunct(1, "setMisc"); // the door is now shattered
    }
    else
    {
      cout << "You cast Spirit Talk in your attempts to communicate " <<
      endl << "with the deceased prisoner.  Unfortunately, the Dead" <<
      endl << "are a vengeful lot, and don't care much for the living." <<
      endl << "Since you were not protected with a Magic Circle, the " <<
      endl << "angry spirit of the prisoner delights in devouring your "<<
      endl << "soul.  Take better precautions next time."  << endl <<
      endl << "...and if you didn't realize it yet, you're dead." << endl;
      exit(1);
    }
  }
  else
  {
    cout << "While there is no use for your spell here, you do " <<
    endl << "get in some practice." << endl;
  }
  }
}

void take(Myr & wytch, Room rooms[], char token2[])
{
  if (rooms[0].searchItem(token2) == 1)
  {
    cout << "You pick up the " << token2 << " and put it away in your " <<
            "pack." << endl;
    wytch.insertInv(token2, 1); // add the item to Ego inventory
    rooms[0].removeItem(token2); // remove the item from the room
  }
  else
    cout << "You don't see any such item here." << endl;
}
