/* room14.h - Hallway
 * Created: 2. August 1999 
 * Last modified: 2. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init14(char string[]);
void desc14();
void look14(Myr &, Room [], char [], char []);
void cast14(Myr &, char [], char []);
void open14(Room [], char [], char []);
void read14(Myr, char []);

void room14(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc14();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init14(token);
    init14(token2);
    init14(token3);
    init14(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
    {
      wytch.printInv();
    }
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You cannot go in that direction." << endl;
    }
    else if (!strcmp(token, "d") || !strcmp(token, "down"))
    {
      cout << "You can't go in that direction either." << endl;

    }
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
    {
      if (rooms[14].doFunct2(0, "isLocked") == 1)
      {
        cout << "You will have to open the door first before you can go"<<
	endl << "in that direction." << endl;
      }
      else
      {
        cout << "You enter into the treasury."<< endl;
        rooms[15].setPrevRoom(14);
        setroom = 15;
        strcpy(breakloop, "bye");
      }
    }
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
    {
      cout << "You walk down the hallway." << endl;
      rooms[11].setPrevRoom(14);
      setroom = 11;
      strcpy(breakloop, "bye");
      
    }
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
    {
      cout << "You walk down the hallway to the west." << endl << endl;
      rooms[10].setPrevRoom(14);
      setroom = 10;
      strcpy(breakloop, "bye");
    }
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look14(wytch, rooms, token2, token3);
    }
    else if (!strcmp(token, "cast"))
    {
      cast14(wytch, token2, token3);
    }
    else if (!strcmp(token, "open") || !strcmp(token, "unlock"))
      open14(rooms, token2, token3);
    else if (!strcmp(token, "read"))
      read14(wytch, token2);
    else if (!strcmp(token, "get") && !strcmp(token2, "sign"))
    {
      cout << "What, are you one of those perverse sign-thieves or "<<
              "something?!" << endl;
    }
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[14].insertItem(token2, 1);
    }
    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init14(char string[])                                  *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init14(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc14()                                              *
 * Gives the room description                            *
 ********************************************************/
void desc14()
{
  cout <<
  endl << "You have entered another long hallway which stretches from the"<<
  endl << "east to the west.  To the north is a single door." << endl;
}


/*********************************************************
 * look14()                                             *
 ********************************************************/
void look14(Myr & wytch, Room rooms[], char token2[], char token3[])
{

  if (!strcmp(token2, "corridor") || !strcmp(token2, "hall"))
  {
    cout << "It is a fairly ordinary and dull, stone corridor running" <<
    endl << "in an east to west direction." << endl;
  }
  else if (!strcmp(token2, "door") || !strcmp(token2, "doors"))
  {
    if (rooms[14].doFunct2(0, "isLocked") == 1)
    {
      cout << "It is a simple door, except it has no visible means of " <<
      endl << "opening it.  There is a sign above the door." << endl;
    }
    else
    {
      cout << "The door is wide open."<< endl;
    }
  }
  else if (!strcmp(token2, "wall"))
    cout << "You see a sign on the wall above the door." << endl;
  else if (!strcmp(token2, "sign"))
  {
    if (wytch.retSpellState("Translate") == 1)
      cout << "The sign says: TREASURY." << endl;
    else
      cout << "You cannot read the strange script." << endl;
  }
  else if (!strcmp(token2, "room"))
    desc14();
  else
    desc14();
}


/*********************************************************
 * cast14()                                               *
 ********************************************************/
void cast14(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0"))
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted); // check to see if spell is valid

  if (casted == 1)
  {
    if (!strcmp(token2, "Unlock"))
    {
      cout << "Your spell isn't strong enough to break the door's " <<
      endl << "puzzle lock." << endl;
    }
    else  if (!strcmp(token2, "Translate"))
    {
      cout << "You cast the Translate spell.  You now have the "<<
      endl << "ability to read strange and foreign languages." <<
      endl;
    }
    else if (!strcmp(token2, "Sense"))
    {
      cout << "You Sense that there is a strong ward surrounding this" << 
      endl << "door and it won't be opened by simple magic spells." <<
      endl;
    }
    else if (!strcmp(token2, "Mental Key"))
    {
      cout << "The strong ward surrounding the door prevents you from " <<
      endl << "getting a clear understanding of how the lock works, but"<<
      endl << "it seems to work off a sequence or pattern of numbers. "<<
      endl;
    }
    else
    {
      cout << "While there is no use for your spell here, you do "<<
      endl << "get in some practice." << endl;
    }
  }
}

void open14(Room rooms[], char token2[], char token3[])
{
  int answer = 0;
  int randomnum = get_random(1, 2);

  if (!strcmp(token2, "door") || !strcmp(token2, "doors"))
  {
    cout << "You see a series of numbers which act as a puzzle lock on the"<<
    endl << "door.  You must determine the next number to open the door." <<
    endl << endl;

    if (randomnum == 1)
    {
      cout << "1, 2, 3, 5, 7, 11, 13, 17, 23, 29, ____" << endl << "> ";
      cin >> answer;
      if (answer == 31)
      {
	cout << "The door unlocks and swings open." << endl;
	rooms[14].doFunct(0, "unlockDoor");
	rooms[14].doFunct(0, "openDoor");
      }
      else
	cout << "The door remains very closed and very locked." << endl;
    }
    
    if (randomnum == 2)
    {
      cout << "1, 1, 2, 3, 5, 8, 13, ____" << endl << "> ";
      cin >> answer;
      if (answer == 21)
      {
	cout << "The door unlocks and swings open." << endl;
	rooms[14].doFunct(0, "unlockDoor");
	rooms[14].doFunct(0, "openDoor");
      }
      else
	cout << "The door remains very closed and very locked." << endl;
    }
  }
}

void read14(Myr wytch, char token2[])
{
  if (!strcmp(token2, "sign"))
  {
    if (wytch.retSpellState("Translate") == 1)
      cout << "The sign says: TREASURY." << endl;
    else
      cout << "You cannot read the strange script." << endl;
  }
  else
    cout << "What are you trying to read?" << endl;
}
