/* room16.h - Altar room 
 * Created: 3. August 1999 
 * Last modified: 6. August 1999
 */

//#include <iostream.h>
//#include <stdlib.h> // necessary for exit(1)
//#include <stdio.h>
//#include "Enemy.h"

void init16(char string[]);
void desc16(Room []);
void look16(Room [], char [], char []);
void cast16(Myr &, char [], char []);

void room16(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";
  Enemy psycho("Psychomancer", 15, 100); // declare Psychomancer


  desc16(rooms);

  if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) == 1)
  {
    cout << "The crazed Psychomancer becons you with a bony hand.  He" <<
    endl << "pulls out a small dagger.  You prepare for combat." << endl;

    battle(wytch, psycho);
  }

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You leave the altar room."  << endl;
      rooms[9].setPrevRoom(16);
      setroom = 9;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
    {
      cout << "You walk over to the dark side of the room." << endl;
      rooms[17].setPrevRoom(16);
      setroom = 17;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
    {
      cout << "You walk over to the light side of the room." << endl;
      rooms[20].setPrevRoom(16);
      setroom = 20;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "u") || !strcmp(token, "up"))
    {
      if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) == 1)
      {
	cout << "You step into the column of light and begin to rise " <<
	endl << "to the ceiling." << endl;
	rooms[21].setPrevRoom(16);
	setroom = 21;
	strcpy(breakloop, "bye");
      }
      else
      {
	cout << "You gaze up, but the room is so large that you can't "<<
	endl << "even see the ceiling." << endl;
      }
    }
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look16(rooms, token2, token3);
    }
    else if (!strcmp(token, "cast"))
    {
      cast16(wytch, token2, token3);
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 4); // 4 is just a general number for now
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[16].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init16(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init16(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc16()                                             *
 * Gives the room description                            *
 ********************************************************/
void desc16(Room rooms[])
{
  cout << 
  endl << "You have entered a large altar room, split into two sections."<<
  endl << "To the west the room is mostly dark with an altar near the "<<
  endl << "end.  The opposite side of the room is nearly a mirror image,"<<
  endl << "except it is light, not dark. On the floor at the center of" << 
  endl << "the room is an insignia." << endl;
  if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) == 1)
  {
    cout << "There is a tall column of light extending from the insignia"<<
    endl << "on the floor which reaches up to the ceiling." << endl;
  }
}


/*********************************************************
 * look16()                                             *
 ********************************************************/
void look16(Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "insignia") || !strcmp(token2, "symbol"))
  {
    if (rooms[3].getMiscvar(0) == 0)
    {
      cout << "There is an intricate Q-shaped design on the floor.  You "<<
      endl << "wonder about its meaning." << endl;
    }
    else
    {
      cout << "You see the symbol representing Angwyn in the center of "<<
      endl << "the floor, dividing the dark and light sides of the room."<<
      endl;
    }
  }
  else if (!strcmp(token2, "ground") || !strcmp(token2, "floor"))
  {
    cout << "You see an odd, circular symbol dividing the dark and light"<<
    endl << "sides of the room." << endl;
  }
  else if (!strcmp(token2, "light") || !strcmp(token2, "column"))
  {
    if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) == 1)
    {
      cout << "There is a tall column of light extending from the insignia"<<
      endl << "on the floor which reaches up to the ceiling." << endl;
    }
    else
    {
      cout << "What light?  You mean the light at the end of the tunnel"<<
      endl << "when you die? " << endl;
    }
  }
  else if (!strcmp(token2, "room") || !strcmp(token2, ""))
    desc16(rooms);
  else
    desc16(rooms);
}


/*********************************************************
 * cast16()                                             *
 ********************************************************/
void cast16(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Sense"))
    {
      cout << "You sense a great clashing between Good and Evil in this"<<
      endl << "room, almost as if they were trying to merge together"<<
      endl << "into one entity." << endl;
    }
    else if (!strcmp(token2, "Translate"))
    {
      cout << "You now have the ability to translate similar languages to"<<
      endl << "ones you already know." << endl;
    }
    else if (!strcmp(token2, "History"))
    {
      cout << "Ages ago, this used to be the Main Temple for Angwyn.  The" <<
      endl << "followers would perform ceremonies here, dedicated to both" <<
      endl << "the Immortals Cylindrix and Mordekai, in attempts to bring" <<
      endl << "them back together again to form one Being." << endl;
    }
    else if (!strcmp(token2, "Psychic Block"))
      cout << "You prepare yourself from psychic attacks." << endl;
    else
    {
      cout << "While practicing was fun, your spell has no immediate use"<<
      endl << "here right now." << endl;
    }
  }
}
