/* room20.h - Altar room (Cylindrix side)
 * Created: 3. August 1999 
 * Last modified: 10. August 1999

 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init20(char string[]);
void desc20();
void look20(Room [], char [], char [], char []);
void cast20(Myr &, char [], char []);
void place20(Myr &, Room [], char [], char [], char []);
void give20(Myr &, Room [], char[], char []);

void room20(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc20();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
    {
      cout << "You walk back to the center of the altar room." << endl;
      rooms[16].setPrevRoom(20);
      setroom = 16;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
      cout << "You can't go in that direction." << endl;
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look20(rooms, token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast20(wytch, token2, token3);
    }
    else if (!strcmp(token, "get") || !strcmp(token, "take"))
    {
      if (!strcmp(token2, "candle") && (rooms[20].searchItem("candle") != 0))
	cout << "You don't need to take the candle back." << endl;
      else
	cout << "There is nothing here which you can take." << endl;
    }
    else if (!strcmp(token, "put") || !strcmp(token, "place"))
      place20(wytch, rooms, token2, token3, token4);
    else if (!strcmp(token, "give"))
      give20(wytch, rooms, token2, token3);
    else if (!strcmp(token, "sacrifice") && !strcmp(token2, "self"))
    {
      cout << "Cylindrix is normally not a blood-thirsty and vengeful Immortal,"<<
      endl << "so trying to sacrifice yourself probably wouldn't be the best "<<
      endl << "course of action here." << endl;
    }
    else if (!strcmp(token, "light") && !strcmp(token2, "candle"))
    {
      if (rooms[20].searchItem("candle") != 0)
      {
	if (wytch.searchInv("tinderbox") != 0)
	{
	cout << "Using your tinderbox, you light the candle. The altar seems"<<
	endl << "to glow in happiness." << endl;
        rooms[16].setMiscvar(1, 1); // the light altar portion is finished
	if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) ==1)
	{
	  cout <<
	  endl << "You then notice a light behind you.  As you turn, you " <<
	  endl << "see a column of light rising up from the symbol on the" <<
	  endl << "floor.  A crazed-looking man stands in the center of " <<
	  endl << "the column of light." << endl;
	}
	}
	else if (wytch.retCircle() == 2 && wytch.retEssence() >= 1 )
	{
	  cout << "You expend a small portion of your Essence to light the "<<
	  endl << "candle.  The altar seems to glow in happiness." << endl;
          rooms[16].setMiscvar(1, 1); // the light altar portion is finished
	  if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) ==1)
	  {
	    cout <<
	    endl << "You then notice a light behind you.  As you turn, you " <<
	    endl << "see a column of light rising up from the symbol on the" <<
	    endl << "floor.  A crazed-looking man stands in the center of " <<
	    endl << "the column of light." << endl;
	  }
	}
	else
	{
	  cout << "You have nothing with which to light the candle." << endl;
	}
      }
      else
      {
	cout << "You need to put a candle on the altar first before you can "<<
        endl << "light it." << endl;
      }
    }
    else if (!strcmp(token, "use") && !strcmp(token2, "tinderbox"))
    {
      if (wytch.searchInv("tinderbox") != 0)
      {
      if (rooms[20].searchItem("candle") != 0)
      {
	cout << "Using your tinderbox, you light the candle. The altar seems"<<
	endl << "to glow in happiness." << endl;
        rooms[16].setMiscvar(1, 1); // the light altar portion is finished
	if (rooms[16].getMiscvar(0) == 1 && rooms[16].getMiscvar(1) ==1)
	{
	  cout <<
	  endl << "You then notice a light behind you.  As you turn, you " <<
	  endl << "see a column of light rising up from the symbol on the" <<
	  endl << "floor.  A crazed-looking man stands in the center of " <<
	  endl << "the column of light." << endl;
	}
      }
      else if (wytch.searchInv("candle") != 0)
      {
	cout << "You will need to place the candle on the altar first," <<
	endl << "before you can light it." << endl;
      }
      else
      {
	cout << "You look around, but cannot find anything suitable to" <<
	endl << "use your tinderbox on." << endl;
      }
      }
      else
        cout << "You don't have a tinderbox." << endl;
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 4); // 4 is just a general number for now
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[20].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init20(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init20(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc20()                                             *
 * Gives the room description                            *
 ********************************************************/
void desc20()
{
  cout << 
  endl << "You are at the light end of the altar room.  There is a simple" <<
  endl << "stone altar here." << endl;
}


/*********************************************************
 * look20()                                             *
 ********************************************************/
void look20(Room rooms[], char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "altar") || !strcmp(token3, "altar"))
  {
    cout << "This altar of Cylindrix is a simple stone altar carved from" <<
    endl << "a white stone.  There is a small offering bowl carved into"<<
    endl << "the top of the altar.  ";
    if (rooms[20].searchItem("amulet") !=0)
    {
      cout << "Your gift of a candle is " << 
      endl << "standing in the offering bowl." << endl;
    }
    else
    {
      cout << "The offering bowl is empty, " <<
      endl << "and almost begs to you for a gift." << endl;
    }
  }
  else if (!strcmp(token2, "room") || !strcmp(token2, ""))
    desc20();
  else
    cout << "";
}


/*********************************************************
 * cast20()                                             *
 ********************************************************/
void cast20(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Sense") || !strcmp(token2, "History"))
    {
      cout << "You feel very warm and comfortable at this end of the large"<<
      endl << "room.  You almost feel tempted to take a short nap." << endl;
    }
    else if (!strcmp(token2, "Translate"))
    {
      cout << "You now have the ability to translate similar languages to"<<
      endl << "ones you already know." << endl;
    }
    else if (!strcmp(token2, "Psychic Block"))
      cout << "You prepare yourself from psychic attacks." << endl;
    else
    {
      cout << "While practicing was fun, your spell has no immediate use"<<
      endl << "here right now." << endl;
    }
  }
}

void place20(Myr & wytch, Room rooms[], char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "candle"))
  {
    if (wytch.searchInv("candle") != 0)
    {
      if (!strcmp(token3, "altar") || !strcmp(token4, "altar"))
      {
        cout << "You place the candle on the altar.  While the altar seems"<<
	endl << "a bit more vibrant than before, this offering doesn't seem"<<
	endl << "complete." << endl;
        wytch.removeInv("candle");
        rooms[20].insertItem("candle", 1);
      }
      else if (!strcmp(token3, "bowl") || !strcmp(token4, "bowl"))
      {
        cout << "You place the candle on the altar.  While the altar seems"<<
	endl << "a bit more vibrant than before, this offering doesn't seem"<<
	endl << "complete." << endl;
        wytch.removeInv("candle");
        rooms[20].insertItem("candle", 1);
      }
      else if (!strcmp(token3, "\0"))
	cout << "Where do you want to put the candle?" << endl;
      else
	cout << "You shouldn't put the candle there." << endl;
    }
    else
      cout << "You don't have an candle to use." << endl;
  }
  else if (!strcmp(token3, "altar") || !strcmp(token4, "altar"))
  {
    cout << "You try and put the " << token2 << " on the altar, but nothing"<<
    endl << "seems to happen so you take your " << token2 << " back." << endl;
  }
  else
    cout << "You can't use the " << token2 << " here." << endl;
}

void give20(Myr & wytch, Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "candle"))
  {
    if (wytch.searchInv("candle") != 0)
    {
      cout << "You place the candle on the altar.  While the altar seems"<<
      endl << "a bit more vibrant than before, this offering doesn't seem"<<
      endl << "complete." << endl;
      wytch.removeInv("candle");
      rooms[20].insertItem("candle", 1);
    }
    else
      cout << "You don't have a candle to give." << endl;
  }
  else
  {
    cout << "You try and put the " << token2 << " on the altar, but nothing"<<
    endl << "seems to happen so you take your " << token2 << " back." << endl; 
  }  
}




