/* room21.h 
 * Created: 3. August 1999 
 * Last modified: 5. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init21(char string[]);
void desc21(Room []);
void look21(Room [], char [], char [], char []);
void cast21(Myr &, char [], char []);

void room21(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc21(rooms);

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You leave the temple." << endl;
      rooms[22].setPrevRoom(21);
      setroom = 22;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "d") || !strcmp(token, "down"))
      if (rooms[21].doFunct2(0, "isClosed") == 1)
        cout << "You can't go in that direction." << endl;
      else
      {
	cout << "You step into the beam of light and begin floating "<<
	endl << "downwards below the floor." << endl;
	rooms[21].doFunct(0, "closeDoor");  // close & lock the door
	rooms[21].doFunct(0, "lockDoor");
	rooms[16].setPrevRoom(21);
	setroom = 16;
	strcpy(breakloop, "bye");
      }
    else if (!strcmp(token, "u") || !strcmp(token, "up"))
      cout << "You certainly can't go in that direction." << endl;
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
      cout << "You can't go in that direction." << endl;
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
      look21(rooms, token2, token3, token4);
    else if (!strcmp(token, "cast"))
    {
      cast21(wytch, token2, token3);
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 4); // 4 is just a general number for now
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[21].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init21(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init21(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc21()                                             *
 * Gives the room description                            *
 ********************************************************/
void desc21(Room rooms[])
{
  cout << 
  endl << "You stand inside of a circular temple with eight statues lined" <<
  endl << "up along the edge of the temple.  There is a doorway to the" << 
  endl << "south.  ";
  if (rooms[21].doFunct2(0, "isClosed") == 0)
  {
    cout << "A bright column of light is coming out of the floor which"<<
    endl << "seems to lead to a hole in the ground." << endl;
  }
  else
  {
    cout << "There is a large insignia in the center of the floor." << endl;
  }
}


/*********************************************************
 * look21()                                             *
 ********************************************************/
void look21(Room rooms[], char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "ground") || !strcmp(token2, "floor"))
    cout << "There is a large insignia on the floor of the temple." << endl;
  else if (!strcmp(token2, "symbol") || !strcmp(token2, "insignia"))
  {
    if (rooms[3].getMiscvar(0) == 0)
    {
      cout << "You see a strange, intricate Q-shaped insignia design on" <<
      endl << "the floor."  << endl;
    }
    else
      cout << "This strange Q-shaped symbol represents Angwyn." << endl;
  }
  else if (!strcmp(token2, "statues") || !strcmp(token2, "statue"))
  {
    cout << "You gaze at the various statues.  They appear to be very old"<<
    endl << "depictions of people long dead." << endl;
  }
  if (!strcmp(token2, "room") || !strcmp(token2, ""))
    desc21(rooms);
  else
    cout << "";
}


/*********************************************************
 * cast21()                                             *
 ********************************************************/
void cast21(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
  }
}
