/* room22.h - Front of temple and trail
 * Created: 3. August 1999 
 * Last modified: 5. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init22(char string[]);
void desc22();
void look22(char [], char [], char []);
void cast22(Myr &, char [], char []);

void room22(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc22();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init(token);
    init(token2);
    init(token3);
    init(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
    {
      cout << "You enter the temple." << endl;
      rooms[21].setPrevRoom(22);
      setroom = 21;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You walk down the winding trail." << endl;
      rooms[18].setPrevRoom(22);
      setroom = 18;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "se") || !strcmp(token, "southeast"))
    {
      cout << "You walk down the winding trail." << endl;
      rooms[18].setPrevRoom(22);
      setroom = 18;
      strcpy(breakloop, "bye");
    }
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look22(token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast22(wytch, token2, token3);
    }
    else if (!strcmp(token, "climb") && !strcmp(token2, "tree"))
    {
      cout << "Okay, now you want to start climbing trees.  What next? " <<
      endl << "Flying a kite?"  << endl;
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 4); // 4 is just a general number for now
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[22].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init22(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init22(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc22()                                             *
 * Gives the room description                            *
 ********************************************************/
void desc22()
{
  cout << 
  endl << "You are standing in front of a temple.  A winding path leads"<<
  endl << "down to the south." << endl;
}


/*********************************************************
 * look22()                                             *
 ********************************************************/
void look22(char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "temple"))
  {
    cout << "From the outside, the temple looks like it hasn't been used" <<
    endl << "in quite some time.  Part of the columns and walls are falling"<<
    endl << "apart, and various forms of vegetation have begun climbing" <<
    endl << "up the sides and along the columns." << endl;
  }
  else if (!strcmp(token2, "path") || !strcmp(token2, "trail"))
  {
    cout << "A winding, narrow path makes its way down the hill and into" <<
    endl << "the forest.  From where you are standing, you can see a " <<
    endl << "glimpse of the ruins below." << endl;
  }
  else if (!strcmp(token2, "vegetation") || !strcmp(token2, "plants"))
  {
    cout << "The plants growing on the old temple aren't very interesting."<<
    endl;
  }
  else if (!strcmp(token2, "ruins") || !strcmp(token2, "town"))
  {
    cout << "You can't make out much from this perspective.  It would be" <<
    endl << "best to just go down to the village ruins to inspect them." <<
    endl;
  }
  else if (!strcmp(token2, "room") || !strcmp(token2, ""))
    desc22();
  else
    cout << "";
}


/*********************************************************
 * cast22()                                             *
 ********************************************************/
void cast22(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Sense"))
    {
      cout << "While you sense nothing strange about the forest, the temple"<<
      endl << "is faintly radiating in an old type of magic." << endl;
    }
    else if (!strcmp(token2, "History"))
    {
      cout << "You see that many Ages ago a group of cowled figures used to" <<
      endl << "often make their way up this trail to go to the temple during" <<
      endl << "rainy nights." << endl;
    }
    else
    {
      cout << "While you get in some good practice, your spell isn't useful" <<
      endl << "here." << endl;
    }
  }
}
