/* room3.h - Library
 * Created: 26. July 1999 
 * Last modified: 2. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init3(char string[]);
void desc3();
void look3(Myr, Room [], char [], char []);
void cast3(Myr &, char [], char []);
void read3(Room [], char [], char []);
void take3(Myr &, Room [], char[]);

void room3(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc3();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init3(token);
    init3(token2);
    init3(token3);
    init3(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
    {
      cout << "You exit the library through the north exit." << endl;
      rooms[2].setPrevRoom(3);
      setroom = 2;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You exit the library through the south exit." << endl;
      rooms[8].setPrevRoom(3);
      setroom = 8;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "e") || !strcmp(token, "east"))
      cout << "You can't go in that direction." << endl;
    else if (!strcmp(token, "w") || !strcmp(token, "west"))
      cout << "You can't go in that direction." << endl;
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look3(wytch, rooms, token2, token3);
    }
    else if (!strcmp(token, "cast"))
    {
      cast3(wytch, token2, token3);
    }
    else if (!strcmp(token, "read"))
      read3(rooms, token2, token3);
    else if (!strcmp(token, "get") || !strcmp(token, "take"))
      take3(wytch, rooms, token2);
    else if (!strcmp(token, "drink") || !strcmp(token, "eat"))
    {
      cout << "Hey, you shouldn't be eating or drinking in the library!"<<
      endl;
    }
    else if (!strcmp(token, "sit"))
    {
      cout << "You don't have the time right now to sit.  You should be"<<
      endl << "more concerned with escaping from this place."<< endl;
    }
    else if (!strcmp(token, "move") && (!strcmp(token2, "book") || !strcmp(token2, "volume")))
      cout << "What do you think this is?!  King's Quest 3?" << endl;
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[3].insertItem(token2, 1);
    }

    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init3(char string[])                                  *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init3(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc3()                                               *
 * Gives the room description                            *
 ********************************************************/
void desc3()
{
  cout << 
  endl << "You are in a musty library, cluttered with a table and shelves" <<
  endl << "piled with books and scrolls and parchments. On" << 
  endl << "a pedestal near the center of the room is a large," <<
  endl << "open book which attracts your attention.  There are" << 
  endl << "doors at both the north and south ends of the library." << endl;
}


/*********************************************************
 * look3()                                               *
 ********************************************************/
void look3(Myr wytch, Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "pedestal"))
    cout << "There is a large book laying upon the pedestal." << endl;
  else if (!strcmp(token2, "book"))
  {
    cout << "You are glad to see that the book is written in a language"<<
    endl << "you understand.  You carefully turn the frail book so you" <<
    endl << "can read the cover.  The book is entitled 'The History of" <<
    endl << "Angwyn'.  Also on the cover is a strange symbol you've never"<<
    endl << "seen before; it looks like an intricate capital Q."<<
    endl << "You begin to skim through the book to learn about Angwyn,"<<
    endl << "The Great Being.  The book says:" << endl;
    cout <<
    endl << "Angwyn, the Great Begin, existed, but for so long that"<<
    endl << "even he/she could not recall when his/her life had begun."<<
    endl << "When Angwyn could no longer remain stable and whole, he/she"<<
    endl << "split into two separate entities during a panicky rage to"<<
    endl << "form Cylindrix and Mordekai.  Cylindrix was the benevolent,"<<
    endl << "beautiful, feminine part of Angwyn while Mordekai was the "<<
    endl << "opposite of his counterpart.  Together they became the "<<
    endl << "leaders of Good and Evil, later to be known as gods or "<<
    endl << "Immortals, to command the Mortals of the world Torenheim."<<
    endl;
    rooms[3].setMiscvar(0, 1); /* the book has been read, so the 
				  symbol of Angwyn has been identified*/
  }
  else if (!strcmp(token2, "books"))
  {
    if (wytch.retSpellState("Translate") == 0)
    {
    cout << "There are many, many books here stacked haphazardly on the." << 
    endl << "shelves.  You search through them, but you can't read most of"<<
    endl << "the languages they are written in.  The book on the pedestal"<<
    endl << "does attract your attention, though." << endl;
    }
    else
    {
    cout << "There are many, many books here stacked haphazardly on the." << 
    endl << "shelves.  Even with the aid of your Translate spell, you can"<<
    endl << "only make out half of the languages the books are written in."<<
    endl << "You are amazed with the wealth of information which has been"<<
    endl << "accumulated here over the ages.  But even after your extensive"<<
    endl << "search, none of the books particularly interest you except for"<<
    endl << "the one laying open on the pedestal." << endl;
    }
  }
  else if (!strcmp(token2, "shelf") || !strcmp(token2, "shelves"))
  {
    cout << "The shelves are stacked with many dusty scrolls and books." <<
    endl;
  }
  else if (!strcmp(token2, "chair") || !strcmp(token2, "bench"))
  {
    cout << "It is a fairly ordinary bench next to the table.  Through your"<<
    endl << "ingenuity, you surmised that people once used it to sit on."<<
    endl;
  }
  else if (!strcmp(token2, "table"))
  {
    cout << "A table...you've seen one of these before, so it's nothing new."<<
    endl << "An old, dust-smeared bench is next to the table." << endl;
  }
  else if (!strcmp(token2, "room") || !strcmp(token2, "library"))
    desc3();
  else
    desc3();
}


/*********************************************************
 * cast3()                                             *
 ********************************************************/
void cast3(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Sense"))
    {
      cout << "You sense that this room, like many others, has not seen use"<<
      endl << "in many, many years.  Then again, you could tell that just by"<<
      endl << "the thick blanket of dust on everything in visible sight."<<
      endl;
    }
    else if (!strcmp(token2, "History"))
    {
      cout << "You see images of what appear to be cloaked monks or scholars"<<
      endl << "studying in this library." << endl;
    }
    else if (!strcmp(token2, "Translate"))
    {
      cout << "You cast the Translate spell." << endl;
    }
  }
}

void read3(Room rooms[], char token2[], char token3[])
{
  if (!strcmp(token2, "book"))
  {
    cout << "You are glad to see that the book is written in a language"<<
    endl << "you understand.  You carefully turn the frail book so you" <<
    endl << "can read the cover.  The book is entitled 'The History of" <<
    endl << "Angwyn'.  Also on the cover is a strange symbol you've never"<<
    endl << "seen before; it looks like an intricate capital Q."<<
    endl << "You begin to skim through the book to learn about Angwyn,"<<
    endl << "The Great Being.  The book says:" << endl;
    cout <<
    endl << "Angwyn, the Great Begin, existed, but for so long that"<<
    endl << "even he/she could not recall when his/her life had begun."<<
    endl << "When Angwyn could no longer remain stable and whole, he/she"<<
    endl << "split into two separate entities during a panicky rage to"<<
    endl << "form Cylindrix and Mordekai.  Cylindrix was the benevolent,"<<
    endl << "beautiful, feminine part of Angwyn while Mordekai was the "<<
    endl << "opposite of his counterpart.  Together they became the "<<
    endl << "leaders of Good and Evil, later to be known as gods or "<<
    endl << "Immortals, to command the Mortals of the world Torenheim."<<
    endl;
    rooms[3].setMiscvar(0, 1); /* the book has been read, so the 
				  symbol of Angwyn has been identified*/
  }
  else if (!strcmp(token2, "books"))
  {
    cout << "It would take you years to even try and read all of the books"<<
    endl << "in this library.  Try reading the book on the pedestal instead"<<
    endl << "(hint...hint)." << endl;
  }
  else if (!strcmp(token2, "scroll") || !strcmp(token2, "scrolls"))
    cout << "Try taking a scroll first before reading it." << endl;
  else
    cout << "What are you trying to read?" << endl;
}

void take3(Myr & wytch, Room rooms[], char token2[])
{
  if (!strcmp(token2, "scroll"))
  {
    if (rooms[3].searchItem("scroll") != 0)
    {
      cout << "You search among the piles of stacked scrolls, and " <<
      endl << "come upon one which you might find useful.  You take"<<
      endl << "the scroll and read it.  You now know the ";
      if (wytch.retCircle() == 1)
      {
	cout << "Acid Burn spell." << endl;
	wytch.addSpell("Acid Burn", 5);
	rooms[3].removeItem("scroll");
      }
      else if (wytch.retCircle() == 2)
      {
	cout << "Fire Wind spell." << endl;
	wytch.addSpell("Fire Wind", 25);
	rooms[3].removeItem("scroll");
      }
      else if (wytch.retCircle() == 3)
      {
	cout << "Psychic Blast spell." << endl;
	wytch.addSpell("Psychic Blast", 6);
	rooms[3].removeItem("scroll");
      }
      else
      {
	cout << "Drain spell." << endl;
	wytch.addSpell("Drain", 7);
	rooms[3].removeItem("scroll");
      }
    }
    else
    {
      cout << "You look through the scrolls, but you don't find anything"<<
      endl << "which might be of use to you." << endl;
    }
  }
  else if (!strcmp(token2, "book"))
  {
    cout << "While this book might prove useful, it is far too heavy and"<<
    endl << "bulky to carry around.  You will have to settle with just " <<
    endl << "reading it instead." << endl;
  }
  else if (!strcmp(token2, "books"))
  {
    cout << "You cannot take the " << token2 << ".  They are not yours."<<
    endl << "But you can try and read them instead." << endl;
  }
  else if (!strcmp(token2, "pedestal"))
  {
    cout << "Are you kidding?!  Why would you want to carrying that thing"<<
    endl << "around with you.  Don't worry about it, the pedestal is just"<<
    endl << "fine where it is right now." << endl;
  }
  else if (!strcmp(token2, "chair") || !strcmp(token2, "table"))
  {
    cout << "Sorry, but we aren't going to let you take that.  It's much"<<
    endl << "too bulky for you to be carrying around for the rest of your"<<
    endl << "adventure.  Anyway, you won't need it...trust us." << endl;
  }
  else
    cout << "What are you trying to take?" << endl;
}
