/* room5.h 
 * Created: 23. June 1999 
 * Last modified: 7. August 1999
 */

#include <iostream.h>
#include <stdlib.h> // necessary for exit(1)
#include <stdio.h>

void init5(char string[]);
void desc5();
void look5(char [], char [], char []);
void cast5(Myr &, char [], char []);
void quiz5(Myr &);

void room5(Myr & wytch, Room rooms[], int & setroom)
{
  char command[44], token[10], token2[10], token3[10], token4[10];
  char breakloop[4] = "";


  desc5();

  do
  {

    printf("\n> ");

    /* initialize the tokens */
    init5(token);
    init5(token2);
    init5(token3);
    init5(token4);

    gets(command);
    sscanf(command, "%s %s %s %s", token, token2, token3, token4);

    /* Scan the command for any useless words */
    scanprep(token, token2, token3, token4);

    if (!strcmp(token, "exit") && !strcmp(token2, "game"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "quit"))
    {
      strcpy(breakloop, "bye");
      setroom = 100;
    }
    else if (!strcmp(token, "help"))
      help();
    else if (!strcmp(token, "tutorial"))
      tutorial();
    else if (!strcmp(command, "save") || !strcmp(command, "save game"))
      savegame(setroom, wytch, rooms);
    else if (!strcmp(command, "restore") || !strcmp(command, "restore game"))
      restoregame(setroom, wytch, rooms, breakloop);
    else if (!strcmp(token, "i") || !strcmp(token, "inventory"))
      wytch.printInv();
    else if (!strcmp(token, "stats"))
      wytch.stats();
    else if (!strcmp(token, "n") || !strcmp(token, "north"))
    {
      rooms[2].setPrevRoom(5);
      setroom = 2;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
    {
      cout << "You go down the hallway." << endl;
      rooms[8].setPrevRoom(5);
      setroom = 8;
      strcpy(breakloop, "bye");
    }
    else if (!strcmp(token, "s") || !strcmp(token, "south"))
      cout << "You can't go that direction yet..." << endl;
    else if (!strcmp(token, "open") || !strcmp(token, "unlock"))
      quiz5(wytch);
    else if ((!strcmp(token, "fuck")) || (!strcmp(token, "shit")))
    {
      cout << "Well, if that's the way you're going to be..." << endl;
      exit(1);
    }
    else if (!strcmp(token, "asshole") || !strcmp(token, "Microsoft"))
    {
      cout << "This game doesn't tolerate such foul language." << endl;
      exit(1);
    }
    else if (!strcmp(token, "look"))
    {
      look5(token2, token3, token4);
    }
    else if (!strcmp(token, "cast"))
    {
      cast5(wytch, token2, token3);
    }
    else if (!strcmp(token, "drink"))
      drink(wytch, token2, token3, 0);
    else if (!strcmp(token, "drop"))
    {
      wytch.removeInv(token2);
      rooms[5].insertItem(token2, 1);
    }
    else if (!strcmp(token, "read") && !strcmp(token2, "sign"))
      cout << "There is no sign here to read." << endl;
    else
      cout << "";
  }
  while(strcmp(breakloop, "bye") != 0);
}

/*********************************************************
 * init5(char string[])                                *
 * initialize the tokens to clear them out               *
 ********************************************************/
void init5(char string[])
{
  for (int i = 0; i < 10; i++)
    string[i] = '\0';
}


/*********************************************************
 * desc5()                                               *
 * Gives the room description                            *
 ********************************************************/
void desc5()
{
  cout << "You are in another hallway which runs perpendicular to" <<
  endl << "the hallway you just left.  The only noticeable feature" <<
  endl << "is the handleless door to the east." << endl;
}


/*********************************************************
 * look5()                                               *
 ********************************************************/
void look5(char token2[], char token3[], char token4[])
{
  if (!strcmp(token2, "door"))
  {
    cout << "You inspect the door, but see nothing unusual about " <<
    endl << "it, except for the lack of any normal means of opening"<<
    endl << "it, and the strange design engraved on the door.  The" <<
    endl << "design seems to depict a penguin with an apple in its" <<
    endl << "mouth while jumping out a window." << endl;
  }
  else if (!strcmp(token2, "sign"))
    cout << "There is no sign here to read." << endl;
  else if (!strcmp(token2, "room") || (!strcmp(token2, "hallway")))
    desc5();
  else
    desc5();
}


/*********************************************************
 * castk5()                                              *
 ********************************************************/
void cast5(Myr & wytch, char token2[], char token3[])
{
  int casted = 0; // initially the spell has not been cast yet

  // concatenate token2 & token 3
  if (strcmp(token3, "\0")) // if token is not NULL
  {
    strcat(token2, " ");
    strcat(token2, token3);
  }

  wytch.castSpell(token2, casted);

  if (casted == 1)
  {
    if (!strcmp(token2, "Unlock") || !strcmp(token2, "Mental Key"))
    {
      cout << "To your dismay, your spell doesn't trigger the magical" <<
      endl << "puzzle lock." << endl;
    }
    else if (!strcmp(token2, "Sense"))
    {
      cout << "You sense a spell-lock surrounding the door." << endl;
    }
    else
    {
      cout << "While you get in some good practice, that spell was not" <<
      endl << "useful here." << endl;
    }
  }
}


/*********************************************************
 * quiz5()                                               *
 ********************************************************/
void quiz5(Myr & wytch)
{
  char choice;
  int  right = 0;

  cout << "A voice intones inside your head: 'You must answer me, these"<<
  endl << "questions three, 'ere the other side ye see...er...sorry," <<
  endl << "wrong script...just answer the questions..." << endl << endl;

  cout << "Which programming language is associated with Kernigan & " <<
          "Richie?" << 
  endl << "a. Java" <<
  endl << "b. FORTRAN" <<
  endl << "c. C" <<
  endl << "d. COBOL" << endl << "> ";
  cin >> choice;
  if (choice == 'c')
    right++;
  else
  {
    cout << "You get a small shock for the wrong answer." << endl << endl;
    wytch.modLife(-1);
  }
  
  cout << "Which one of these pairs started the company Apple " << 
          "Computer, Inc?" <<
  endl << "a. Bill Gates & Paul Allen" <<
  endl << "b. Bullwinkle & Rocky" <<
  endl << "c. Samson & Son" <<
  endl << "d. Steve Jobs & Steve Wozniak" <<
  endl << "e. Kernigan & Richie" << endl << "> ";
  cin >> choice;
  if (choice == 'd')
  {
    right++;
    cout << endl;
  }
  else
  {
    cout << "You receive a small shock for your wrong answer." << endl << 
    endl;
    wytch.modLife(-1);
  }

  cout << "Who is considered the first programmer?" << 
  endl << "a. Ada Lovelace Byron" <<
  endl << "b. Bill Gates" <<
  endl << "c. Charles Babbage" <<
  endl << "d. Linus Torvalds" <<
  endl << "e. Alan Turing" << endl << "> ";
  cin >> choice;
  if (choice == 'a')
  {
    right++;
    cout << endl;
  }
  else if (choice == 'b')
  {
    cout << "Yeah, right!  Stop smoking all that crack! You receive a" <<
    endl << "large shock for your stupid answer." << endl;
    wytch.modLife(-25);
    if (wytch.retLife() <= 0)
    {
      cout << "Due to your incredibly INGENIOUS answer, you are now" <<
      endl << "dead.  Maybe you shouldn't select such STUPID answers" <<
      endl << "next time." << endl;
      exit(1);
    }
  }
  else
  {
    cout << "You receive a small shock for your incorrect answer." <<
    endl;
    wytch.modLife(-1);
  }

  if (right == 3)
  { cout <<
    endl << "The door swings open with your final correct answer. You" <<
    endl << "peak your head into the room to find....a room full of " <<
    endl << "computer programmers busily working away at software " <<
    endl << "applications.  Hmmm...it figures, only a computer geek " <<
    endl << "would be able to answer the Door's ridiculous questions." <<
    endl << "You shake your head in confusion, close the door and " <<
    endl << "continue your quest."<< endl;
  }
  else
    cout <<endl<< "The door remains quiet and completely unmoving."<<endl;
}
